<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/pc_mowse_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.textRainbow_lv0_p1 { color: #add8e6; }
.textRainbow_lv0_p2 { color: #add8e6; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">   1 </span>11/28/86  pc_mowse_
<span id="L2" class="LineNr">   2 </span>
<span id="L3" class="LineNr">   3 </span>
<span id="L4" class="LineNr">   4 </span>This is a collection of subroutines <span class="textRainbow_lv0_p0">(</span>found in pc_mowse_.archive<span class="textRainbow_lv0_p0">)</span>
<span id="L5" class="LineNr">   5 </span>which provide a subroutine interface for the applications writer
<span id="L6" class="LineNr">   6 </span>to PC MOWSE.
<span id="L7" class="LineNr">   7 </span>
<span id="L8" class="LineNr">   8 </span>
<span id="L9" class="LineNr">   9 </span>Entry points in pc_mowse_:
<span id="L10" class="LineNr">  10 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L11" class="LineNr">  11 </span>
<span id="L12" class="LineNr">  12 </span>
<span id="L13" class="LineNr">  13 </span>:Entry:  conrqst:  11/28/86  conrqst
<span id="L14" class="LineNr">  14 </span>
<span id="L15" class="LineNr">  15 </span>
<span id="L16" class="LineNr">  16 </span>Function:
<span id="L17" class="LineNr">  17 </span>Requests a connection to an application which has been
<span id="L18" class="LineNr">  18 </span>loaded by sending a &quot;WSRQSTCN&quot; minor capability to the requested
<span id="L19" class="LineNr">  19 </span>application.
<span id="L20" class="LineNr">  20 </span>
<span id="L21" class="LineNr">  21 </span>
<span id="L22" class="LineNr">  22 </span>Syntax:
<span id="L23" class="LineNr">  23 </span>int conrqst<span class="textRainbow_lv0_p0">(</span>cap_name<span class="textRainbow_lv0_o0">,</span>args<span class="textRainbow_lv0_o0">,</span>system<span class="textRainbow_lv0_o0">,</span>mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L24" class="LineNr">  24 </span>    char *cap_name;
<span id="L25" class="LineNr">  25 </span>    char *args;
<span id="L26" class="LineNr">  26 </span>    int system;
<span id="L27" class="LineNr">  27 </span>    mcb *mcb_ptr;
<span id="L28" class="LineNr">  28 </span>
<span id="L29" class="LineNr">  29 </span>
<span id="L30" class="LineNr">  30 </span>Arguments:
<span id="L31" class="LineNr">  31 </span>cap_name <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L32" class="LineNr">  32 </span>    The name of the capability to be connected.
<span id="L33" class="LineNr">  33 </span>args <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L34" class="LineNr">  34 </span>    Any command line arguments which may be necessary if the
<span id="L35" class="LineNr">  35 </span>    capability is to be started before the connection is made.
<span id="L36" class="LineNr">  36 </span>system <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L37" class="LineNr">  37 </span>    The system of the capability being connected to.
<span id="L38" class="LineNr">  38 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L39" class="LineNr">  39 </span>    The pointer to the application's MOWSE Control Block
<span id="L40" class="LineNr">  40 </span>    assigned by a call to cretinst.
<span id="L41" class="LineNr">  41 </span>
<span id="L42" class="LineNr">  42 </span>
<span id="L43" class="LineNr">  43 </span>Returns:
<span id="L44" class="LineNr">  44 </span>0        - no error
<span id="L45" class="LineNr">  45 </span>Or an error code defined in the appendix.
<span id="L46" class="LineNr">  46 </span>
<span id="L47" class="LineNr">  47 </span>
<span id="L48" class="LineNr">  48 </span>Examples:
<span id="L49" class="LineNr">  49 </span>ecode = conrqst <span class="textRainbow_lv0_p0">(</span>&quot;bft&quot;<span class="textRainbow_lv0_o0">,</span> &quot;load&quot;<span class="textRainbow_lv0_o0">,</span> WSREMOTE<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L50" class="LineNr">  50 </span>
<span id="L51" class="LineNr">  51 </span>
<span id="L52" class="LineNr">  52 </span>:Entry:  conresp:  11/28/86  conresp
<span id="L53" class="LineNr">  53 </span>
<span id="L54" class="LineNr">  54 </span>
<span id="L55" class="LineNr">  55 </span>Function:
<span id="L56" class="LineNr">  56 </span>Replies to an application's request for a connection.  This
<span id="L57" class="LineNr">  57 </span>allows the application of the conrqst call to be notified
<span id="L58" class="LineNr">  58 </span>either of this application's acceptance of the connect request <span class="textRainbow_lv0_p0">(</span>by
<span id="L59" class="LineNr">  59 </span>supplying the new major capability_number<span class="textRainbow_lv0_p0">)</span> or rejection of the
<span id="L60" class="LineNr">  60 </span>request <span class="textRainbow_lv0_p0">(</span>by supplying an error code<span class="textRainbow_lv0_p0">)</span>.  The application which
<span id="L61" class="LineNr">  61 </span>made the request for connection will receive WSRESPCN which
<span id="L62" class="LineNr">  62 </span>will indicate the success or fail of the request.
<span id="L63" class="LineNr">  63 </span>
<span id="L64" class="LineNr">  64 </span>
<span id="L65" class="LineNr">  65 </span>Syntax:
<span id="L66" class="LineNr">  66 </span>int conresp <span class="textRainbow_lv0_p0">(</span>status<span class="textRainbow_lv0_o0">,</span>cap_num<span class="textRainbow_lv0_o0">,</span>mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L67" class="LineNr">  67 </span>    int status,
<span id="L68" class="LineNr">  68 </span>        cap_num;
<span id="L69" class="LineNr">  69 </span>        mcb_ptr,
<span id="L70" class="LineNr">  70 </span>
<span id="L71" class="LineNr">  71 </span>
<span id="L72" class="LineNr">  72 </span>Arguments:
<span id="L73" class="LineNr">  73 </span>status  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L74" class="LineNr">  74 </span>    The acceptance/rejectance of the connect request.
<span id="L75" class="LineNr">  75 </span>    Values WSACCEPT
<span id="L76" class="LineNr">  76 </span>            WSREJECT
<span id="L77" class="LineNr">  77 </span>cap_num  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L78" class="LineNr">  78 </span>    The major capability number of the application to which
<span id="L79" class="LineNr">  79 </span>    the response is destined.
<span id="L80" class="LineNr">  80 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L81" class="LineNr">  81 </span>    A pointer to the mcb which is associated with the
<span id="L82" class="LineNr">  82 </span>    connection.  The mcb can be either the original mcb
<span id="L83" class="LineNr">  83 </span>    obtained by the application, or the address of a new mcb
<span id="L84" class="LineNr">  84 </span>    obtained by the application specifically for this
<span id="L85" class="LineNr">  85 </span>    connection.
<span id="L86" class="LineNr">  86 </span>
<span id="L87" class="LineNr">  87 </span>
<span id="L88" class="LineNr">  88 </span>Returns:
<span id="L89" class="LineNr">  89 </span>0        - no error
<span id="L90" class="LineNr">  90 </span>Or an error code defined in the appendix.
<span id="L91" class="LineNr">  91 </span>
<span id="L92" class="LineNr">  92 </span>
<span id="L93" class="LineNr">  93 </span>Examples:
<span id="L94" class="LineNr">  94 </span>ecode = conresp <span class="textRainbow_lv0_p0">(</span>WSACCEPT<span class="textRainbow_lv0_o0">,</span> request_capability<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L95" class="LineNr">  95 </span>                 new_mcb_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L96" class="LineNr">  96 </span>ecode = conresp <span class="textRainbow_lv0_p0">(</span>WSREJECT<span class="textRainbow_lv0_o0">,</span> request_capability<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L97" class="LineNr">  97 </span>                 NULL<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L98" class="LineNr">  98 </span>
<span id="L99" class="LineNr">  99 </span>
<span id="L100" class="LineNr"> 100 </span>:Entry:  cretinst:  11/28/86  cretinst
<span id="L101" class="LineNr"> 101 </span>
<span id="L102" class="LineNr"> 102 </span>
<span id="L103" class="LineNr"> 103 </span>Function:
<span id="L104" class="LineNr"> 104 </span>Registers the calling routine with MOWSE by assigning it a
<span id="L105" class="LineNr"> 105 </span>major capability number and adding it to MOWSE's capability
<span id="L106" class="LineNr"> 106 </span>table.  The calling routine must supply the name by which it
<span id="L107" class="LineNr"> 107 </span>is to be known to MOWSE, and the entry point describing where
<span id="L108" class="LineNr"> 108 </span>it is to be invoked by an execute capability.
<span id="L109" class="LineNr"> 109 </span>
<span id="L110" class="LineNr"> 110 </span>
<span id="L111" class="LineNr"> 111 </span>Syntax:
<span id="L112" class="LineNr"> 112 </span>int cretinst <span class="textRainbow_lv0_p0">(</span>cap_name<span class="textRainbow_lv0_o0">,</span> entry<span class="textRainbow_lv0_o0">,</span> inbuff_len<span class="textRainbow_lv0_o0">,</span> outbuff_len<span class="textRainbow_lv0_o0">,</span>
<span id="L113" class="LineNr"> 113 </span>              data_ptr<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L114" class="LineNr"> 114 </span>  char cap_name<span class="textRainbow_lv0_p1">[</span>WSCAPLEN<span class="textRainbow_lv0_p1">]</span>;
<span id="L115" class="LineNr"> 115 </span>  int <span class="textRainbow_lv0_p0">(</span>*entry<span class="textRainbow_lv0_p0">)()</span>;
<span id="L116" class="LineNr"> 116 </span>  int inbuff_len;
<span id="L117" class="LineNr"> 117 </span>  int outbuff_len;
<span id="L118" class="LineNr"> 118 </span>  char *data_ptr;
<span id="L119" class="LineNr"> 119 </span>  mcb **mcb_ptr;
<span id="L120" class="LineNr"> 120 </span>
<span id="L121" class="LineNr"> 121 </span>
<span id="L122" class="LineNr"> 122 </span>Arguments:
<span id="L123" class="LineNr"> 123 </span>cap_name  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L124" class="LineNr"> 124 </span>    A null terminated string of characters specifying the name
<span id="L125" class="LineNr"> 125 </span>    by which the calling capability will be known to MOWSE.
<span id="L126" class="LineNr"> 126 </span>entry  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L127" class="LineNr"> 127 </span>    A pointer to the function which will be invoked when MOWSE
<span id="L128" class="LineNr"> 128 </span>    has a message destined for the application.
<span id="L129" class="LineNr"> 129 </span>inbuff_len  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L130" class="LineNr"> 130 </span>    The length <span class="textRainbow_lv0_p0">(</span>in characters<span class="textRainbow_lv0_p0">)</span> of the message buffer which
<span id="L131" class="LineNr"> 131 </span>    receives argument data from incoming messages.  The buffer
<span id="L132" class="LineNr"> 132 </span>    will be allocated with the size specified or WSMINBUF,
<span id="L133" class="LineNr"> 133 </span>    whichever is larger.
<span id="L134" class="LineNr"> 134 </span>
<span id="L135" class="LineNr"> 135 </span>
<span id="L136" class="LineNr"> 136 </span>outbuff_len  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L137" class="LineNr"> 137 </span>    The length <span class="textRainbow_lv0_p0">(</span>in characters<span class="textRainbow_lv0_p0">)</span> of the message buffer which
<span id="L138" class="LineNr"> 138 </span>    will be used for outgoing messages.  The buffer will be
<span id="L139" class="LineNr"> 139 </span>    allocated with the size specified or WSMINBUF, whichever
<span id="L140" class="LineNr"> 140 </span>    is larger.
<span id="L141" class="LineNr"> 141 </span>data_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L142" class="LineNr"> 142 </span>    A pointer to the application's local data which is to be
<span id="L143" class="LineNr"> 143 </span>    preserved across calls to the capability through MOWSE.
<span id="L144" class="LineNr"> 144 </span>    This provides an alternate method to static variables of
<span id="L145" class="LineNr"> 145 </span>    preserving data across the starts and stops of the
<span id="L146" class="LineNr"> 146 </span>    application's life in MOWSE thus providing reentrancy.
<span id="L147" class="LineNr"> 147 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L148" class="LineNr"> 148 </span>    The address of the pointer to the application's MOWSE
<span id="L149" class="LineNr"> 149 </span>    Control Block which will be used by MOWSE to maintain
<span id="L150" class="LineNr"> 150 </span>    information on the application.
<span id="L151" class="LineNr"> 151 </span>
<span id="L152" class="LineNr"> 152 </span>
<span id="L153" class="LineNr"> 153 </span>Returns:
<span id="L154" class="LineNr"> 154 </span>0        - no error
<span id="L155" class="LineNr"> 155 </span>Or an error code defined in the appendix.
<span id="L156" class="LineNr"> 156 </span>
<span id="L157" class="LineNr"> 157 </span>
<span id="L158" class="LineNr"> 158 </span>Notes:
<span id="L159" class="LineNr"> 159 </span>All applications which expect to receive messages must have
<span id="L160" class="LineNr"> 160 </span>registered with MOWSE <span class="textRainbow_lv0_p0">(</span>through cretinst<span class="textRainbow_lv0_p0">)</span> in order to receive
<span id="L161" class="LineNr"> 161 </span>messages.  A message is provided to the application when the
<span id="L162" class="LineNr"> 162 </span>destination of the message specifies the major capability
<span id="L163" class="LineNr"> 163 </span>number of the application.  The application will then be
<span id="L164" class="LineNr"> 164 </span>invoked at the entry name provided with the message <span class="textRainbow_lv0_p0">(</span>argument
<span id="L165" class="LineNr"> 165 </span>data<span class="textRainbow_lv0_p0">)</span>, its length, and a pointer to the applications
<span id="L166" class="LineNr"> 166 </span>data_block as follows:
<span id="L167" class="LineNr"> 167 </span>
<span id="L168" class="LineNr"> 168 </span>
<span id="L169" class="LineNr"> 169 </span>  application_$entry_point <span class="textRainbow_lv0_p0">(</span>minor_cap<span class="textRainbow_lv0_o0">,</span> major_sender<span class="textRainbow_lv0_o0">,</span> arg_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L170" class="LineNr"> 170 </span>          arg_length<span class="textRainbow_lv0_o0">,</span> data_block_ptr<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L171" class="LineNr"> 171 </span>
<span id="L172" class="LineNr"> 172 </span>
<span id="L173" class="LineNr"> 173 </span>          char      minor_cap;
<span id="L174" class="LineNr"> 174 </span>          int       major_sender;
<span id="L175" class="LineNr"> 175 </span>          char      *arg_ptr;
<span id="L176" class="LineNr"> 176 </span>          int       arg_length;
<span id="L177" class="LineNr"> 177 </span>          char      *data_block_ptr
<span id="L178" class="LineNr"> 178 </span>
<span id="L179" class="LineNr"> 179 </span>
<span id="L180" class="LineNr"> 180 </span>The buffers inbuff and outbuff allow MOWSE to send and receive
<span id="L181" class="LineNr"> 181 </span>messages longer than one communications packet <span class="textRainbow_lv0_p0">(</span>defined by
<span id="L182" class="LineNr"> 182 </span>WSPAKSIZ<span class="textRainbow_lv0_p0">)</span> in a manner transparent to the capability.
<span id="L183" class="LineNr"> 183 </span>
<span id="L184" class="LineNr"> 184 </span>
<span id="L185" class="LineNr"> 185 </span>Examples:
<span id="L186" class="LineNr"> 186 </span>ecode = cretinst <span class="textRainbow_lv0_p0">(</span>&quot;bft&quot;<span class="textRainbow_lv0_o0">,</span> bft_process<span class="textRainbow_lv0_o0">,</span> 256<span class="textRainbow_lv0_o0">,</span> 256<span class="textRainbow_lv0_o0">,</span> data_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L187" class="LineNr"> 187 </span>                  &amp;mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L188" class="LineNr"> 188 </span>
<span id="L189" class="LineNr"> 189 </span>
<span id="L190" class="LineNr"> 190 </span>:Entry:  destinst:  11/28/86  destinst
<span id="L191" class="LineNr"> 191 </span>
<span id="L192" class="LineNr"> 192 </span>
<span id="L193" class="LineNr"> 193 </span>Function:
<span id="L194" class="LineNr"> 194 </span>Removes the reference to the application from MOWSE's
<span id="L195" class="LineNr"> 195 </span>capability table and deallocates the inbuff and outbuff
<span id="L196" class="LineNr"> 196 </span>message buffer space.
<span id="L197" class="LineNr"> 197 </span>
<span id="L198" class="LineNr"> 198 </span>
<span id="L199" class="LineNr"> 199 </span>Syntax:
<span id="L200" class="LineNr"> 200 </span>int destinst <span class="textRainbow_lv0_p0">(</span>mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L201" class="LineNr"> 201 </span>  mcb **mcb_ptr;
<span id="L202" class="LineNr"> 202 </span>
<span id="L203" class="LineNr"> 203 </span>
<span id="L204" class="LineNr"> 204 </span>Arguments:
<span id="L205" class="LineNr"> 205 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L206" class="LineNr"> 206 </span>    The address of the pointer to the application's MOWSE
<span id="L207" class="LineNr"> 207 </span>    Control Block assigned by a call to &quot;cretinst&quot;.
<span id="L208" class="LineNr"> 208 </span>
<span id="L209" class="LineNr"> 209 </span>
<span id="L210" class="LineNr"> 210 </span>Returns:
<span id="L211" class="LineNr"> 211 </span>0        - no error
<span id="L212" class="LineNr"> 212 </span>Or an error code defined in the appendix.
<span id="L213" class="LineNr"> 213 </span>
<span id="L214" class="LineNr"> 214 </span>
<span id="L215" class="LineNr"> 215 </span>Notes:
<span id="L216" class="LineNr"> 216 </span>If this is the final instance and it is being destroyed, then
<span id="L217" class="LineNr"> 217 </span>all memory occupied by the application is released including
<span id="L218" class="LineNr"> 218 </span>memory occupied by its code.
<span id="L219" class="LineNr"> 219 </span>
<span id="L220" class="LineNr"> 220 </span>
<span id="L221" class="LineNr"> 221 </span>Examples:
<span id="L222" class="LineNr"> 222 </span>ecode = destinst <span class="textRainbow_lv0_p0">(</span>&amp;mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L223" class="LineNr"> 223 </span>
<span id="L224" class="LineNr"> 224 </span>
<span id="L225" class="LineNr"> 225 </span>:Entry:  disrqst:  11/28/86  disrqst
<span id="L226" class="LineNr"> 226 </span>
<span id="L227" class="LineNr"> 227 </span>
<span id="L228" class="LineNr"> 228 </span>Function:
<span id="L229" class="LineNr"> 229 </span>Requests that conversation to the specified application be
<span id="L230" class="LineNr"> 230 </span>terminated by sending a &quot;WSRQSTDS&quot; to the specified
<span id="L231" class="LineNr"> 231 </span>capability.
<span id="L232" class="LineNr"> 232 </span>
<span id="L233" class="LineNr"> 233 </span>
<span id="L234" class="LineNr"> 234 </span>Syntax:
<span id="L235" class="LineNr"> 235 </span>int disrqst<span class="textRainbow_lv0_p0">(</span>cap_num<span class="textRainbow_lv0_o0">,</span>mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L236" class="LineNr"> 236 </span>    int cap_num;
<span id="L237" class="LineNr"> 237 </span>    mcb *mcb_ptr;
<span id="L238" class="LineNr"> 238 </span>
<span id="L239" class="LineNr"> 239 </span>
<span id="L240" class="LineNr"> 240 </span>Arguments:
<span id="L241" class="LineNr"> 241 </span>cap_num  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L242" class="LineNr"> 242 </span>    The major capability number of the application which is to
<span id="L243" class="LineNr"> 243 </span>    be disconnected.
<span id="L244" class="LineNr"> 244 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L245" class="LineNr"> 245 </span>    The pointer to the application's MOWSE Control Block
<span id="L246" class="LineNr"> 246 </span>    assigned by a call to cretinst.
<span id="L247" class="LineNr"> 247 </span>
<span id="L248" class="LineNr"> 248 </span>
<span id="L249" class="LineNr"> 249 </span>Returns:
<span id="L250" class="LineNr"> 250 </span>0        - no error
<span id="L251" class="LineNr"> 251 </span>Or an error code defined in the appendix.
<span id="L252" class="LineNr"> 252 </span>
<span id="L253" class="LineNr"> 253 </span>
<span id="L254" class="LineNr"> 254 </span>Examples:
<span id="L255" class="LineNr"> 255 </span>ecode = disrqst <span class="textRainbow_lv0_p0">(</span>bft_major_cap<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L256" class="LineNr"> 256 </span>
<span id="L257" class="LineNr"> 257 </span>
<span id="L258" class="LineNr"> 258 </span>:Entry:  disresp:  11/28/86  disresp
<span id="L259" class="LineNr"> 259 </span>
<span id="L260" class="LineNr"> 260 </span>
<span id="L261" class="LineNr"> 261 </span>Function:
<span id="L262" class="LineNr"> 262 </span>Notifies the application which requested a disconnect that the
<span id="L263" class="LineNr"> 263 </span>disconnect was accepted or rejected.  A &quot;WSRESPDS&quot; message
<span id="L264" class="LineNr"> 264 </span>will be sent to the application which made the disconnect
<span id="L265" class="LineNr"> 265 </span>request.
<span id="L266" class="LineNr"> 266 </span>
<span id="L267" class="LineNr"> 267 </span>
<span id="L268" class="LineNr"> 268 </span>Syntax:
<span id="L269" class="LineNr"> 269 </span>int disresp<span class="textRainbow_lv0_p0">(</span>status<span class="textRainbow_lv0_o0">,</span>cap_num<span class="textRainbow_lv0_o0">,</span>mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L270" class="LineNr"> 270 </span>    int status,
<span id="L271" class="LineNr"> 271 </span>        cap_num;
<span id="L272" class="LineNr"> 272 </span>    mcb *mcb_ptr;
<span id="L273" class="LineNr"> 273 </span>
<span id="L274" class="LineNr"> 274 </span>
<span id="L275" class="LineNr"> 275 </span>Arguments:
<span id="L276" class="LineNr"> 276 </span>status  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L277" class="LineNr"> 277 </span>    The acceptance/rejectance of the disconnect request.
<span id="L278" class="LineNr"> 278 </span>    Values WSACCEPT
<span id="L279" class="LineNr"> 279 </span>            WSREJECT
<span id="L280" class="LineNr"> 280 </span>cap_num  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L281" class="LineNr"> 281 </span>    The major capability number of the application to which
<span id="L282" class="LineNr"> 282 </span>    the response is destined.
<span id="L283" class="LineNr"> 283 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L284" class="LineNr"> 284 </span>    The pointer to the application's MOWSE control block
<span id="L285" class="LineNr"> 285 </span>    assigned by a call to cretinst.
<span id="L286" class="LineNr"> 286 </span>
<span id="L287" class="LineNr"> 287 </span>
<span id="L288" class="LineNr"> 288 </span>Returns:
<span id="L289" class="LineNr"> 289 </span>0        - no error
<span id="L290" class="LineNr"> 290 </span>Or an error code defined in the appendix.
<span id="L291" class="LineNr"> 291 </span>
<span id="L292" class="LineNr"> 292 </span>
<span id="L293" class="LineNr"> 293 </span>Examples:
<span id="L294" class="LineNr"> 294 </span>ecode = disresp <span class="textRainbow_lv0_p0">(</span>WSACCEPT<span class="textRainbow_lv0_o0">,</span> request_capability<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L295" class="LineNr"> 295 </span>ecode = disresp <span class="textRainbow_lv0_p0">(</span>WSREJECT<span class="textRainbow_lv0_o0">,</span> request_capability<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L296" class="LineNr"> 296 </span>
<span id="L297" class="LineNr"> 297 </span>
<span id="L298" class="LineNr"> 298 </span>:Entry:  execap:  11/28/86  execap
<span id="L299" class="LineNr"> 299 </span>
<span id="L300" class="LineNr"> 300 </span>
<span id="L301" class="LineNr"> 301 </span>Function:
<span id="L302" class="LineNr"> 302 </span>Executes the minor capability function of the specified major
<span id="L303" class="LineNr"> 303 </span>capability with the arguments provided.
<span id="L304" class="LineNr"> 304 </span>
<span id="L305" class="LineNr"> 305 </span>
<span id="L306" class="LineNr"> 306 </span>Syntax:
<span id="L307" class="LineNr"> 307 </span>int execap <span class="textRainbow_lv0_p0">(</span>major_num<span class="textRainbow_lv0_o0">,</span> minor_num<span class="textRainbow_lv0_o0">,</span> arg_ptr<span class="textRainbow_lv0_o0">,</span> arg_len<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L308" class="LineNr"> 308 </span>  int major_num;
<span id="L309" class="LineNr"> 309 </span>  int minor_num;
<span id="L310" class="LineNr"> 310 </span>  char *arg_ptr;
<span id="L311" class="LineNr"> 311 </span>  int arg_len;
<span id="L312" class="LineNr"> 312 </span>  mcb *mcb_ptr;
<span id="L313" class="LineNr"> 313 </span>
<span id="L314" class="LineNr"> 314 </span>
<span id="L315" class="LineNr"> 315 </span>Arguments:
<span id="L316" class="LineNr"> 316 </span>major_num  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L317" class="LineNr"> 317 </span>    The identifier of the capability to be executed.
<span id="L318" class="LineNr"> 318 </span>minor_num  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L319" class="LineNr"> 319 </span>    The identifier of a specific function to be performed by
<span id="L320" class="LineNr"> 320 </span>    the specified major_capability.
<span id="L321" class="LineNr"> 321 </span>arg_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L322" class="LineNr"> 322 </span>    A pointer to the argument data to be supplied to the
<span id="L323" class="LineNr"> 323 </span>    specified capability, NULL if there is no argument data.
<span id="L324" class="LineNr"> 324 </span>arg_len  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L325" class="LineNr"> 325 </span>    The length of the argument data in bytes, zero if there is
<span id="L326" class="LineNr"> 326 </span>    no data.
<span id="L327" class="LineNr"> 327 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L328" class="LineNr"> 328 </span>    The pointer to the application's MOWSE Control Block
<span id="L329" class="LineNr"> 329 </span>    assigned by a call to &quot;cretinst&quot;.
<span id="L330" class="LineNr"> 330 </span>
<span id="L331" class="LineNr"> 331 </span>
<span id="L332" class="LineNr"> 332 </span>Returns:
<span id="L333" class="LineNr"> 333 </span>0        - no error
<span id="L334" class="LineNr"> 334 </span>Or an error code defined in the appendix.
<span id="L335" class="LineNr"> 335 </span>
<span id="L336" class="LineNr"> 336 </span>
<span id="L337" class="LineNr"> 337 </span>Notes:
<span id="L338" class="LineNr"> 338 </span>It is up to the calling application to convert the argument
<span id="L339" class="LineNr"> 339 </span>data into character string format which can be interpreted by
<span id="L340" class="LineNr"> 340 </span>the application being called as a character string of data.
<span id="L341" class="LineNr"> 341 </span>
<span id="L342" class="LineNr"> 342 </span>If MOWSE was incapable of starting execution of the specified
<span id="L343" class="LineNr"> 343 </span>application, the calling application will be notified through
<span id="L344" class="LineNr"> 344 </span>the predefined minor capability WSFAILCP.
<span id="L345" class="LineNr"> 345 </span>
<span id="L346" class="LineNr"> 346 </span>
<span id="L347" class="LineNr"> 347 </span>Examples:
<span id="L348" class="LineNr"> 348 </span>ecode = execap <span class="textRainbow_lv0_p0">(</span>pcfooid<span class="textRainbow_lv0_o0">,</span> addnumid<span class="textRainbow_lv0_o0">,</span> numarg_ptr<span class="textRainbow_lv0_o0">,</span> numarg_len<span class="textRainbow_lv0_o0">,</span>
<span id="L349" class="LineNr"> 349 </span>                mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L350" class="LineNr"> 350 </span>
<span id="L351" class="LineNr"> 351 </span>
<span id="L352" class="LineNr"> 352 </span>:Entry:  execom:  11/28/86  execom
<span id="L353" class="LineNr"> 353 </span>
<span id="L354" class="LineNr"> 354 </span>
<span id="L355" class="LineNr"> 355 </span>Function:
<span id="L356" class="LineNr"> 356 </span>Sends a command string to the command processor on the
<span id="L357" class="LineNr"> 357 </span>specified system.
<span id="L358" class="LineNr"> 358 </span>
<span id="L359" class="LineNr"> 359 </span>
<span id="L360" class="LineNr"> 360 </span>Syntax:
<span id="L361" class="LineNr"> 361 </span>int execom <span class="textRainbow_lv0_p0">(</span>command_string<span class="textRainbow_lv0_o0">,</span> system<span class="textRainbow_lv0_o0">,</span> command_id<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L362" class="LineNr"> 362 </span>  char *command_string;
<span id="L363" class="LineNr"> 363 </span>  int system;
<span id="L364" class="LineNr"> 364 </span>  int *command_id;
<span id="L365" class="LineNr"> 365 </span>  mcb *mcb_ptr
<span id="L366" class="LineNr"> 366 </span>
<span id="L367" class="LineNr"> 367 </span>
<span id="L368" class="LineNr"> 368 </span>Arguments:
<span id="L369" class="LineNr"> 369 </span>command_string  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L370" class="LineNr"> 370 </span>    A null terminated string of characters that is typed
<span id="L371" class="LineNr"> 371 </span>    on the system to execute the command.
<span id="L372" class="LineNr"> 372 </span>system  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L373" class="LineNr"> 373 </span>    A constant specifying the system the command_string will be
<span id="L374" class="LineNr"> 374 </span>    executed on.
<span id="L375" class="LineNr"> 375 </span>    Values WSLOCAL
<span id="L376" class="LineNr"> 376 </span>           WSREMOTE
<span id="L377" class="LineNr"> 377 </span>
<span id="L378" class="LineNr"> 378 </span>
<span id="L379" class="LineNr"> 379 </span>command_id  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L380" class="LineNr"> 380 </span>    The tag which will be associated with the command_string
<span id="L381" class="LineNr"> 381 </span>    being executed and the resultant WSCOMREP predefined minor
<span id="L382" class="LineNr"> 382 </span>    capability.
<span id="L383" class="LineNr"> 383 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L384" class="LineNr"> 384 </span>    The pointer to the application's MOWSE Control Block
<span id="L385" class="LineNr"> 385 </span>    assigned by a call to &quot;cretinst&quot;.
<span id="L386" class="LineNr"> 386 </span>
<span id="L387" class="LineNr"> 387 </span>
<span id="L388" class="LineNr"> 388 </span>Returns:
<span id="L389" class="LineNr"> 389 </span>0        - no error
<span id="L390" class="LineNr"> 390 </span>Or an error code defined in the appendix.
<span id="L391" class="LineNr"> 391 </span>
<span id="L392" class="LineNr"> 392 </span>
<span id="L393" class="LineNr"> 393 </span>Notes:
<span id="L394" class="LineNr"> 394 </span>There are two ways in which information is returned to the
<span id="L395" class="LineNr"> 395 </span>calling application.  One is the immediate return which provides the
<span id="L396" class="LineNr"> 396 </span>error information as specified in code.  The second is through a
<span id="L397" class="LineNr"> 397 </span>delayed response message via the predefined minor capability WSCOMREP
<span id="L398" class="LineNr"> 398 </span>which provides the calling application with information at the
<span id="L399" class="LineNr"> 399 </span>completion of the command.  Two types of information are
<span id="L400" class="LineNr"> 400 </span>provided.  One is a success or failure of the command - this is
<span id="L401" class="LineNr"> 401 </span>important in the case of remote commands which caused the command
<span id="L402" class="LineNr"> 402 </span>processor on the remote system to fail.  The second is to provide the
<span id="L403" class="LineNr"> 403 </span>handler with the major capability number of the application which may
<span id="L404" class="LineNr"> 404 </span>have been loaded by the command.
<span id="L405" class="LineNr"> 405 </span>
<span id="L406" class="LineNr"> 406 </span>
<span id="L407" class="LineNr"> 407 </span>Since execute_command calls the system's command processor
<span id="L408" class="LineNr"> 408 </span>with the command_string, an application may be called which
<span id="L409" class="LineNr"> 409 </span>loads itself into the MOWSE.  Thus an application may use
<span id="L410" class="LineNr"> 410 </span>execute_command to load another application.
<span id="L411" class="LineNr"> 411 </span>
<span id="L412" class="LineNr"> 412 </span>
<span id="L413" class="LineNr"> 413 </span>Output from a command executing on the PC <span class="textRainbow_lv0_p0">(</span>by the PC's command
<span id="L414" class="LineNr"> 414 </span>processor<span class="textRainbow_lv0_p0">)</span> appears on the terminal screen with total
<span id="L415" class="LineNr"> 415 </span>disregard to MOWSE.  If a terminal emulator is executing and
<span id="L416" class="LineNr"> 416 </span>it calls a PC routine through EXECOM - such as &quot;dir&quot; - the
<span id="L417" class="LineNr"> 417 </span>output appears on the screen without passing through the
<span id="L418" class="LineNr"> 418 </span>terminal emulator.
<span id="L419" class="LineNr"> 419 </span>
<span id="L420" class="LineNr"> 420 </span>
<span id="L421" class="LineNr"> 421 </span>Examples:
<span id="L422" class="LineNr"> 422 </span>ecode = execom <span class="textRainbow_lv0_p0">(</span>&quot;dir \user\smith\*.*&quot;<span class="textRainbow_lv0_o0">,</span> WSREMOTE<span class="textRainbow_lv0_o0">,</span> &amp;com_id<span class="textRainbow_lv0_o0">,</span>
<span id="L423" class="LineNr"> 423 </span>                mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L424" class="LineNr"> 424 </span>ecode = execom <span class="textRainbow_lv0_p0">(</span>&quot;ls -d &gt;udd&gt;m&gt;Smith&quot;<span class="textRainbow_lv0_o0">,</span>WSLOCAL<span class="textRainbow_lv0_o0">,</span> &amp;com_id<span class="textRainbow_lv0_o0">,</span>
<span id="L425" class="LineNr"> 425 </span>                mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L426" class="LineNr"> 426 </span>ecode = execom <span class="textRainbow_lv0_p0">(</span>&quot;bft&quot;<span class="textRainbow_lv0_o0">,</span> WSREMOTE<span class="textRainbow_lv0_o0">,</span> &amp;com_id<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L427" class="LineNr"> 427 </span>
<span id="L428" class="LineNr"> 428 </span>
<span id="L429" class="LineNr"> 429 </span>:Entry:  findname:  11/28/86  findname
<span id="L430" class="LineNr"> 430 </span>
<span id="L431" class="LineNr"> 431 </span>
<span id="L432" class="LineNr"> 432 </span>Function:
<span id="L433" class="LineNr"> 433 </span>Finds the name of a capability given its major capability
<span id="L434" class="LineNr"> 434 </span>number.
<span id="L435" class="LineNr"> 435 </span>
<span id="L436" class="LineNr"> 436 </span>
<span id="L437" class="LineNr"> 437 </span>Syntax:
<span id="L438" class="LineNr"> 438 </span>int findname <span class="textRainbow_lv0_p0">(</span>major_num<span class="textRainbow_lv0_o0">,</span> cap_name<span class="textRainbow_lv0_p0">)</span>;
<span id="L439" class="LineNr"> 439 </span>  int major_number;
<span id="L440" class="LineNr"> 440 </span>  char cap_name<span class="textRainbow_lv0_p1">[</span>WSCAPLEN<span class="textRainbow_lv0_p1">]</span>;
<span id="L441" class="LineNr"> 441 </span>
<span id="L442" class="LineNr"> 442 </span>
<span id="L443" class="LineNr"> 443 </span>Arguments:
<span id="L444" class="LineNr"> 444 </span>major_number  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L445" class="LineNr"> 445 </span>    The major capability number of the capability name to be
<span id="L446" class="LineNr"> 446 </span>    found.
<span id="L447" class="LineNr"> 447 </span>cap_name  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L448" class="LineNr"> 448 </span>    The name of the capability found, 0 length if not found.
<span id="L449" class="LineNr"> 449 </span>
<span id="L450" class="LineNr"> 450 </span>
<span id="L451" class="LineNr"> 451 </span>Returns:
<span id="L452" class="LineNr"> 452 </span>0        - no error
<span id="L453" class="LineNr"> 453 </span>Or an error code defined in the appendix.
<span id="L454" class="LineNr"> 454 </span>
<span id="L455" class="LineNr"> 455 </span>
<span id="L456" class="LineNr"> 456 </span>Notes:
<span id="L457" class="LineNr"> 457 </span>
<span id="L458" class="LineNr"> 458 </span>
<span id="L459" class="LineNr"> 459 </span>Examples:
<span id="L460" class="LineNr"> 460 </span>ecode = findname <span class="textRainbow_lv0_p0">(</span>major_cap<span class="textRainbow_lv0_o0">,</span> cap_name<span class="textRainbow_lv0_p0">)</span>;
<span id="L461" class="LineNr"> 461 </span>
<span id="L462" class="LineNr"> 462 </span>
<span id="L463" class="LineNr"> 463 </span>:Entry:  findnumb:  11/28/86  findnumb
<span id="L464" class="LineNr"> 464 </span>
<span id="L465" class="LineNr"> 465 </span>
<span id="L466" class="LineNr"> 466 </span>Function:
<span id="L467" class="LineNr"> 467 </span>Finds the major capability number of an application given a
<span id="L468" class="LineNr"> 468 </span>capability name.
<span id="L469" class="LineNr"> 469 </span>
<span id="L470" class="LineNr"> 470 </span>
<span id="L471" class="LineNr"> 471 </span>Syntax:
<span id="L472" class="LineNr"> 472 </span>int findnumb <span class="textRainbow_lv0_p0">(</span>cap_name<span class="textRainbow_lv0_o0">,</span> sys_id<span class="textRainbow_lv0_o0">,</span> major_num<span class="textRainbow_lv0_p0">)</span>;
<span id="L473" class="LineNr"> 473 </span>  char cap_name<span class="textRainbow_lv0_p1">[</span>WSCAPLEN<span class="textRainbow_lv0_p1">]</span>;
<span id="L474" class="LineNr"> 474 </span>  int sys_id;
<span id="L475" class="LineNr"> 475 </span>  int *major_num;
<span id="L476" class="LineNr"> 476 </span>
<span id="L477" class="LineNr"> 477 </span>
<span id="L478" class="LineNr"> 478 </span>Arguments:
<span id="L479" class="LineNr"> 479 </span>cap_name  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L480" class="LineNr"> 480 </span>    The capability name to be looked for.
<span id="L481" class="LineNr"> 481 </span>sys_id  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L482" class="LineNr"> 482 </span>    The system which is to be looked at to find the capability
<span id="L483" class="LineNr"> 483 </span>    name.
<span id="L484" class="LineNr"> 484 </span>    Values  WSLOCAL
<span id="L485" class="LineNr"> 485 </span>             WSREMOTE
<span id="L486" class="LineNr"> 486 </span>major_num  <span class="textRainbow_lv0_p0">(</span>input/output<span class="textRainbow_lv0_p0">)</span>
<span id="L487" class="LineNr"> 487 </span>    Indicates where MOWSE is to begin searching of the
<span id="L488" class="LineNr"> 488 </span>    capability table for the name specified, 0 will find the
<span id="L489" class="LineNr"> 489 </span>    first case, and returns the major capability number of the
<span id="L490" class="LineNr"> 490 </span>    found name.
<span id="L491" class="LineNr"> 491 </span>
<span id="L492" class="LineNr"> 492 </span>
<span id="L493" class="LineNr"> 493 </span>Returns:
<span id="L494" class="LineNr"> 494 </span>0        - no error
<span id="L495" class="LineNr"> 495 </span>Or an error code defined in the appendix.
<span id="L496" class="LineNr"> 496 </span>
<span id="L497" class="LineNr"> 497 </span>
<span id="L498" class="LineNr"> 498 </span>Notes:
<span id="L499" class="LineNr"> 499 </span>MOWSE looks for the capability name in its capability table in
<span id="L500" class="LineNr"> 500 </span>the following fashion:
<span id="L501" class="LineNr"> 501 </span>
<span id="L502" class="LineNr"> 502 </span>
<span id="L503" class="LineNr"> 503 </span>    1) If the provided major capability number is 0, MOWSE
<span id="L504" class="LineNr"> 504 </span>    will begin searching from the top of the table specified
<span id="L505" class="LineNr"> 505 </span>    by the sys_id.
<span id="L506" class="LineNr"> 506 </span>    2) If the major capability number is valid, MOWSE will
<span id="L507" class="LineNr"> 507 </span>    begin searching from the next entry.
<span id="L508" class="LineNr"> 508 </span>    3) If the provided sys_id is invalid, MOWSE will search
<span id="L509" class="LineNr"> 509 </span>    the local CAT table from its first entry.
<span id="L510" class="LineNr"> 510 </span>
<span id="L511" class="LineNr"> 511 </span>
<span id="L512" class="LineNr"> 512 </span>Examples:
<span id="L513" class="LineNr"> 513 </span>ecode = findnumb <span class="textRainbow_lv0_p0">(</span>&quot;bft_&quot;<span class="textRainbow_lv0_o0">,</span> WSLOCAL<span class="textRainbow_lv0_o0">,</span> &amp;major_num<span class="textRainbow_lv0_p0">)</span>;
<span id="L514" class="LineNr"> 514 </span>ecode = findnumb <span class="textRainbow_lv0_p0">(</span>&quot;bft_&quot;<span class="textRainbow_lv0_o0">,</span> WSREMOTE<span class="textRainbow_lv0_o0">,</span> &amp;major_num<span class="textRainbow_lv0_p0">)</span>;
<span id="L515" class="LineNr"> 515 </span>
<span id="L516" class="LineNr"> 516 </span>
<span id="L517" class="LineNr"> 517 </span>:Entry:  getbgmes:  11/28/86  getbgmes
<span id="L518" class="LineNr"> 518 </span>
<span id="L519" class="LineNr"> 519 </span>
<span id="L520" class="LineNr"> 520 </span>Function:
<span id="L521" class="LineNr"> 521 </span>Returns one of two types of background messages - placed there
<span id="L522" class="LineNr"> 522 </span>by a call to &quot;putbgmes&quot;.
<span id="L523" class="LineNr"> 523 </span>
<span id="L524" class="LineNr"> 524 </span>
<span id="L525" class="LineNr"> 525 </span>    1) Info messages which are for display only.
<span id="L526" class="LineNr"> 526 </span>    2) Query messages which are to be used to prompt the user
<span id="L527" class="LineNr"> 527 </span>    to provide information which is to be returned to the
<span id="L528" class="LineNr"> 528 </span>    requesting application through a call to &quot;sendqrep&quot;.
<span id="L529" class="LineNr"> 529 </span>
<span id="L530" class="LineNr"> 530 </span>
<span id="L531" class="LineNr"> 531 </span>Syntax:
<span id="L532" class="LineNr"> 532 </span>int getbgmes <span class="textRainbow_lv0_p0">(</span>string<span class="textRainbow_lv0_o0">,</span> type<span class="textRainbow_lv0_o0">,</span> sender_major<span class="textRainbow_lv0_p0">)</span>;
<span id="L533" class="LineNr"> 533 </span>  char *string;
<span id="L534" class="LineNr"> 534 </span>  int *type;
<span id="L535" class="LineNr"> 535 </span>  int *sender_major;
<span id="L536" class="LineNr"> 536 </span>
<span id="L537" class="LineNr"> 537 </span>
<span id="L538" class="LineNr"> 538 </span>Arguments:
<span id="L539" class="LineNr"> 539 </span>string  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L540" class="LineNr"> 540 </span>    The next background message available from MOWSE, placed
<span id="L541" class="LineNr"> 541 </span>    there by a call to &quot;putbgmes&quot;.  The string buffer into
<span id="L542" class="LineNr"> 542 </span>    which the background message is placed must be at least
<span id="L543" class="LineNr"> 543 </span>    one packetsize <span class="textRainbow_lv0_p0">(</span>WSPAKSIZ characters<span class="textRainbow_lv0_p0">)</span> long.
<span id="L544" class="LineNr"> 544 </span>type  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L545" class="LineNr"> 545 </span>    A specifier to the type of background message returned.
<span id="L546" class="LineNr"> 546 </span>    Values WSQUERY
<span id="L547" class="LineNr"> 547 </span>            WSINFO
<span id="L548" class="LineNr"> 548 </span>sender_major  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L549" class="LineNr"> 549 </span>    The major capability number of the application which
<span id="L550" class="LineNr"> 550 </span>    stored the background message through a call to
<span id="L551" class="LineNr"> 551 </span>    &quot;putbgmes&quot;.
<span id="L552" class="LineNr"> 552 </span>
<span id="L553" class="LineNr"> 553 </span>
<span id="L554" class="LineNr"> 554 </span>Returns:
<span id="L555" class="LineNr"> 555 </span>0         - no error
<span id="L556" class="LineNr"> 556 </span>Or an error code defined in the appendix.
<span id="L557" class="LineNr"> 557 </span>
<span id="L558" class="LineNr"> 558 </span>
<span id="L559" class="LineNr"> 559 </span>Notes:
<span id="L560" class="LineNr"> 560 </span>The application which makes this call must be a foreground
<span id="L561" class="LineNr"> 561 </span>application which is responsible for all user I/O.
<span id="L562" class="LineNr"> 562 </span>
<span id="L563" class="LineNr"> 563 </span>
<span id="L564" class="LineNr"> 564 </span>If the message type returned is WSQUERY, the application which
<span id="L565" class="LineNr"> 565 </span>made this call must send a reply to the sender major as it is
<span id="L566" class="LineNr"> 566 </span>stopped, expecting a reply.
<span id="L567" class="LineNr"> 567 </span>
<span id="L568" class="LineNr"> 568 </span>
<span id="L569" class="LineNr"> 569 </span>Examples:
<span id="L570" class="LineNr"> 570 </span>ecode = getbgmes <span class="textRainbow_lv0_p0">(</span>string<span class="textRainbow_lv0_o0">,</span> &amp;type<span class="textRainbow_lv0_o0">,</span> &amp;sender_major<span class="textRainbow_lv0_p0">)</span>;
<span id="L571" class="LineNr"> 571 </span>
<span id="L572" class="LineNr"> 572 </span>
<span id="L573" class="LineNr"> 573 </span>:Entry:  getstat:  11/28/86  getstat
<span id="L574" class="LineNr"> 574 </span>
<span id="L575" class="LineNr"> 575 </span>
<span id="L576" class="LineNr"> 576 </span>Function:
<span id="L577" class="LineNr"> 577 </span>Requests status information from the specified application.
<span id="L578" class="LineNr"> 578 </span>
<span id="L579" class="LineNr"> 579 </span>
<span id="L580" class="LineNr"> 580 </span>Syntax:
<span id="L581" class="LineNr"> 581 </span>int getstat <span class="textRainbow_lv0_p0">(</span>major_num<span class="textRainbow_lv0_o0">,</span> status_request<span class="textRainbow_lv0_o0">,</span> status_result<span class="textRainbow_lv0_p0">)</span>;
<span id="L582" class="LineNr"> 582 </span>  int major_num;
<span id="L583" class="LineNr"> 583 </span>  char *status_request;
<span id="L584" class="LineNr"> 584 </span>  char *status_result;
<span id="L585" class="LineNr"> 585 </span>
<span id="L586" class="LineNr"> 586 </span>
<span id="L587" class="LineNr"> 587 </span>Arguments:
<span id="L588" class="LineNr"> 588 </span>major_num  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L589" class="LineNr"> 589 </span>    The major capability number of the application for which
<span id="L590" class="LineNr"> 590 </span>    status information is requested.
<span id="L591" class="LineNr"> 591 </span>status_request  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L592" class="LineNr"> 592 </span>    The argument data to be provided to the application to be
<span id="L593" class="LineNr"> 593 </span>    called.
<span id="L594" class="LineNr"> 594 </span>status_result  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L595" class="LineNr"> 595 </span>    The resultant character status information.
<span id="L596" class="LineNr"> 596 </span>
<span id="L597" class="LineNr"> 597 </span>
<span id="L598" class="LineNr"> 598 </span>Returns:
<span id="L599" class="LineNr"> 599 </span>0        - no error
<span id="L600" class="LineNr"> 600 </span>Or an error code defined in the appendix.
<span id="L601" class="LineNr"> 601 </span>
<span id="L602" class="LineNr"> 602 </span>
<span id="L603" class="LineNr"> 603 </span>Notes:
<span id="L604" class="LineNr"> 604 </span>This entry must only be called by a foreground application as
<span id="L605" class="LineNr"> 605 </span>it will wait within the call until a response is received.
<span id="L606" class="LineNr"> 606 </span>The requested application is notified of the request via the
<span id="L607" class="LineNr"> 607 </span>predefined minor capability WSSTATUS.
<span id="L608" class="LineNr"> 608 </span>
<span id="L609" class="LineNr"> 609 </span>
<span id="L610" class="LineNr"> 610 </span>Examples:
<span id="L611" class="LineNr"> 611 </span>ecode = getstat <span class="textRainbow_lv0_p0">(</span>bft_major_cap<span class="textRainbow_lv0_o0">,</span> &quot;pending&quot;<span class="textRainbow_lv0_o0">,</span> status<span class="textRainbow_lv0_p0">)</span>;
<span id="L612" class="LineNr"> 612 </span>
<span id="L613" class="LineNr"> 613 </span>
<span id="L614" class="LineNr"> 614 </span>:Entry:  gettdata:  11/28/86  gettdata
<span id="L615" class="LineNr"> 615 </span>
<span id="L616" class="LineNr"> 616 </span>
<span id="L617" class="LineNr"> 617 </span>Function:
<span id="L618" class="LineNr"> 618 </span>Retrieves a string from the terminal buffer and a flag which
<span id="L619" class="LineNr"> 619 </span>determines whether or not there are pending background messages
<span id="L620" class="LineNr"> 620 </span><span class="textRainbow_lv0_p0">(</span>see PUTBGMES and GETBGMES<span class="textRainbow_lv0_p0">)</span>.  The string is destined to be
<span id="L621" class="LineNr"> 621 </span>used as terminal data, ie.  it is expected to be displayed by
<span id="L622" class="LineNr"> 622 </span>the retrieving application on the PC's CRT.
<span id="L623" class="LineNr"> 623 </span>If there is no data in the terminal buffer, a zero length
<span id="L624" class="LineNr"> 624 </span>string will be returned.
<span id="L625" class="LineNr"> 625 </span>
<span id="L626" class="LineNr"> 626 </span>
<span id="L627" class="LineNr"> 627 </span>Syntax:
<span id="L628" class="LineNr"> 628 </span>int gettdata <span class="textRainbow_lv0_p0">(</span>getdata_ptr<span class="textRainbow_lv0_p0">)</span>
<span id="L629" class="LineNr"> 629 </span>  struct get_struc <span class="textRainbow_lv0_p2">{</span>
<span id="L630" class="LineNr"> 630 </span>     char *local_buffer_pointer;
<span id="L631" class="LineNr"> 631 </span>     int local_buffer_size;
<span id="L632" class="LineNr"> 632 </span>     int minor_capability;
<span id="L633" class="LineNr"> 633 </span>     int background_pending_flag;
<span id="L634" class="LineNr"> 634 </span>  <span class="textRainbow_lv0_p2">}</span> *getdata;
<span id="L635" class="LineNr"> 635 </span>
<span id="L636" class="LineNr"> 636 </span>
<span id="L637" class="LineNr"> 637 </span>Arguments:
<span id="L638" class="LineNr"> 638 </span>string_length  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L639" class="LineNr"> 639 </span>    The length of the terminal string that it pointed to in
<span id="L640" class="LineNr"> 640 </span>    the structure below.  0 if the terminal buffer is empty.
<span id="L641" class="LineNr"> 641 </span>getdata_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L642" class="LineNr"> 642 </span>    The pointer to the calling routine's structure which is
<span id="L643" class="LineNr"> 643 </span>    used for input and output arguments.
<span id="L644" class="LineNr"> 644 </span>local_buffer_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L645" class="LineNr"> 645 </span>    A pointer to a buffer into which the retrieved terminal
<span id="L646" class="LineNr"> 646 </span>    data will be placed.
<span id="L647" class="LineNr"> 647 </span>
<span id="L648" class="LineNr"> 648 </span>
<span id="L649" class="LineNr"> 649 </span>local_buffer_size  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L650" class="LineNr"> 650 </span>    The size of the local buffer.  Determines the maximum
<span id="L651" class="LineNr"> 651 </span>    number of characters that can be retrieved.
<span id="L652" class="LineNr"> 652 </span>minor_capability  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L653" class="LineNr"> 653 </span>    The entry point specified by the remote system for
<span id="L654" class="LineNr"> 654 </span>    specialized handling of received terminal data.
<span id="L655" class="LineNr"> 655 </span>background_pending_flag  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L656" class="LineNr"> 656 </span>    Determines if there are background messages pending.  0 if
<span id="L657" class="LineNr"> 657 </span>    none are pending, N for the number of messages pending.
<span id="L658" class="LineNr"> 658 </span>
<span id="L659" class="LineNr"> 659 </span>
<span id="L660" class="LineNr"> 660 </span>Returns:
<span id="L661" class="LineNr"> 661 </span>N - length of terminal data retrieved, 0 if none.
<span id="L662" class="LineNr"> 662 </span>
<span id="L663" class="LineNr"> 663 </span>
<span id="L664" class="LineNr"> 664 </span>Notes:
<span id="L665" class="LineNr"> 665 </span>
<span id="L666" class="LineNr"> 666 </span>
<span id="L667" class="LineNr"> 667 </span>:Entry:  putbgmes:  11/28/86  putbgmes
<span id="L668" class="LineNr"> 668 </span>
<span id="L669" class="LineNr"> 669 </span>
<span id="L670" class="LineNr"> 670 </span>Function:
<span id="L671" class="LineNr"> 671 </span>Provides a background application with the means of displaying
<span id="L672" class="LineNr"> 672 </span>one of two types of special messages to the foreground channel
<span id="L673" class="LineNr"> 673 </span>through a foreground application such as the terminal
<span id="L674" class="LineNr"> 674 </span>emulator.
<span id="L675" class="LineNr"> 675 </span>
<span id="L676" class="LineNr"> 676 </span>
<span id="L677" class="LineNr"> 677 </span>    1) Information messages which inform the user such as
<span id="L678" class="LineNr"> 678 </span>    errors and status.
<span id="L679" class="LineNr"> 679 </span>    2) Query messages which ask the user for input, which is
<span id="L680" class="LineNr"> 680 </span>    relayed back to the requesting application through the
<span id="L681" class="LineNr"> 681 </span>    predefined minor capability WSQRYREP.
<span id="L682" class="LineNr"> 682 </span>
<span id="L683" class="LineNr"> 683 </span>
<span id="L684" class="LineNr"> 684 </span>Syntax:
<span id="L685" class="LineNr"> 685 </span>int putbgmes <span class="textRainbow_lv0_p0">(</span>mcb_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_o0">,</span> caller<span class="textRainbow_lv0_o0">,</span> control<span class="textRainbow_lv0_o0">,</span> arg1<span class="textRainbow_lv0_o0">,</span>...<span class="textRainbow_lv0_o0">,</span>argN<span class="textRainbow_lv0_p0">)</span>;
<span id="L686" class="LineNr"> 686 </span>  mcb *mcb_ptr;
<span id="L687" class="LineNr"> 687 </span>  int code;
<span id="L688" class="LineNr"> 688 </span>  char *caller;
<span id="L689" class="LineNr"> 689 </span>  char *control;
<span id="L690" class="LineNr"> 690 </span>
<span id="L691" class="LineNr"> 691 </span>
<span id="L692" class="LineNr"> 692 </span>Arguments:
<span id="L693" class="LineNr"> 693 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L694" class="LineNr"> 694 </span>    The pointer to the application's MOWSE Control Block
<span id="L695" class="LineNr"> 695 </span>    assigned by a call to &quot;cretinst&quot;.
<span id="L696" class="LineNr"> 696 </span>code  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L697" class="LineNr"> 697 </span>    Determines the type of the message to be displayed.
<span id="L698" class="LineNr"> 698 </span>    If code is 0, the message will consist only of the
<span id="L699" class="LineNr"> 699 </span>    contents of the control string.
<span id="L700" class="LineNr"> 700 </span>    If code is WSQUERY, the control string will be used to
<span id="L701" class="LineNr"> 701 </span>    prompt the user for a response.
<span id="L702" class="LineNr"> 702 </span>
<span id="L703" class="LineNr"> 703 </span>
<span id="L704" class="LineNr"> 704 </span>caller  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L705" class="LineNr"> 705 </span>    The name of the routine making the call to &quot;putbgmes&quot;.
<span id="L706" class="LineNr"> 706 </span>control  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L707" class="LineNr"> 707 </span>    A &quot;printf&quot; control string.
<span id="L708" class="LineNr"> 708 </span>argI  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L709" class="LineNr"> 709 </span>    printf control arguments to be substituted into the
<span id="L710" class="LineNr"> 710 </span>    control argument.  These arguments are optional.  They can
<span id="L711" class="LineNr"> 711 </span>    only be used however, if the control argument is given
<span id="L712" class="LineNr"> 712 </span>    first.
<span id="L713" class="LineNr"> 713 </span>
<span id="L714" class="LineNr"> 714 </span>
<span id="L715" class="LineNr"> 715 </span>Returns:
<span id="L716" class="LineNr"> 716 </span>0        - always
<span id="L717" class="LineNr"> 717 </span>
<span id="L718" class="LineNr"> 718 </span>
<span id="L719" class="LineNr"> 719 </span>Notes:
<span id="L720" class="LineNr"> 720 </span>All messages are placed into MOWSE for future retrieval
<span id="L721" class="LineNr"> 721 </span>through a call to &quot;getbgmes&quot;.  If there is no foreground
<span id="L722" class="LineNr"> 722 </span>application executing to retrieve these messages, they will go
<span id="L723" class="LineNr"> 723 </span>unnoticed.  This is especially important in the case of query
<span id="L724" class="LineNr"> 724 </span>messages as no response will be returned until the message has
<span id="L725" class="LineNr"> 725 </span>been retrieved and processed by the foreground application.
<span id="L726" class="LineNr"> 726 </span>
<span id="L727" class="LineNr"> 727 </span>
<span id="L728" class="LineNr"> 728 </span>If the code is specified as WSQUERY, the user's response will
<span id="L729" class="LineNr"> 729 </span>be provided to the calling application through the predefined
<span id="L730" class="LineNr"> 730 </span>minor capability WSQRYREP.
<span id="L731" class="LineNr"> 731 </span>
<span id="L732" class="LineNr"> 732 </span>
<span id="L733" class="LineNr"> 733 </span>Examples:
<span id="L734" class="LineNr"> 734 </span>putbgmes <span class="textRainbow_lv0_p0">(</span>mcb_ptr<span class="textRainbow_lv0_o0">,</span> ecode<span class="textRainbow_lv0_o0">,</span> &quot;bft&quot;<span class="textRainbow_lv0_o0">,</span> &quot;retrieve error %d&quot;<span class="textRainbow_lv0_o0">,</span>
<span id="L735" class="LineNr"> 735 </span>          BFTINVDIR<span class="textRainbow_lv0_p0">)</span>;
<span id="L736" class="LineNr"> 736 </span>putbgmes <span class="textRainbow_lv0_p0">(</span>mcb_ptr<span class="textRainbow_lv0_o0">,</span> 0<span class="textRainbow_lv0_o0">,</span> &quot;bft&quot;<span class="textRainbow_lv0_o0">,</span> &quot;transfer of file %s complete&quot;<span class="textRainbow_lv0_o0">,</span>
<span id="L737" class="LineNr"> 737 </span>          trans.name<span class="textRainbow_lv0_p0">)</span>;
<span id="L738" class="LineNr"> 738 </span>putbgmes <span class="textRainbow_lv0_p0">(</span>mcb_ptr<span class="textRainbow_lv0_o0">,</span> WSQUERY<span class="textRainbow_lv0_o0">,</span> &quot;bft&quot;<span class="textRainbow_lv0_o0">,</span>
<span id="L739" class="LineNr"> 739 </span>          &quot;File %s exists overwrite?&quot;<span class="textRainbow_lv0_o0">,</span> trans.name<span class="textRainbow_lv0_p0">)</span>;
<span id="L740" class="LineNr"> 740 </span>
<span id="L741" class="LineNr"> 741 </span>
<span id="L742" class="LineNr"> 742 </span>:Entry:  putstat:  11/28/86  putstat
<span id="L743" class="LineNr"> 743 </span>
<span id="L744" class="LineNr"> 744 </span>
<span id="L745" class="LineNr"> 745 </span>Function:
<span id="L746" class="LineNr"> 746 </span>Sends a status string to the foreground application which made
<span id="L747" class="LineNr"> 747 </span>a request for status information.
<span id="L748" class="LineNr"> 748 </span>
<span id="L749" class="LineNr"> 749 </span>
<span id="L750" class="LineNr"> 750 </span>Syntax:
<span id="L751" class="LineNr"> 751 </span>int putstat <span class="textRainbow_lv0_p0">(</span>status<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L752" class="LineNr"> 752 </span>  char *status;
<span id="L753" class="LineNr"> 753 </span>  mcb *mcb_ptr;
<span id="L754" class="LineNr"> 754 </span>
<span id="L755" class="LineNr"> 755 </span>
<span id="L756" class="LineNr"> 756 </span>Arguments:
<span id="L757" class="LineNr"> 757 </span>status  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L758" class="LineNr"> 758 </span>    A null terminated character string which comprises the
<span id="L759" class="LineNr"> 759 </span>    status information up to a length WSPAKSIZ.
<span id="L760" class="LineNr"> 760 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L761" class="LineNr"> 761 </span>    The pointer to the application's MOWSE Control Block
<span id="L762" class="LineNr"> 762 </span>    assigned by a call to &quot;cretinst&quot;.
<span id="L763" class="LineNr"> 763 </span>
<span id="L764" class="LineNr"> 764 </span>
<span id="L765" class="LineNr"> 765 </span>Returns:
<span id="L766" class="LineNr"> 766 </span>0        - no error
<span id="L767" class="LineNr"> 767 </span>Or an error code defined in the appendix.
<span id="L768" class="LineNr"> 768 </span>
<span id="L769" class="LineNr"> 769 </span>
<span id="L770" class="LineNr"> 770 </span>Notes:
<span id="L771" class="LineNr"> 771 </span>The calling application must have been invoked with the
<span id="L772" class="LineNr"> 772 </span>predefined minor capability WSSTATUS, as it is only then that
<span id="L773" class="LineNr"> 773 </span>the requesting application is awaiting status information.
<span id="L774" class="LineNr"> 774 </span>
<span id="L775" class="LineNr"> 775 </span>
<span id="L776" class="LineNr"> 776 </span>Examples:
<span id="L777" class="LineNr"> 777 </span>ecode = putstat <span class="textRainbow_lv0_p0">(</span>&quot;status no pending requests&quot;<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L778" class="LineNr"> 778 </span>
<span id="L779" class="LineNr"> 779 </span>
<span id="L780" class="LineNr"> 780 </span>:Entry:  puttdata:  11/28/86  puttdata
<span id="L781" class="LineNr"> 781 </span>
<span id="L782" class="LineNr"> 782 </span>
<span id="L783" class="LineNr"> 783 </span>Function:
<span id="L784" class="LineNr"> 784 </span>Sends a data string to the Multics user i/o switch.
<span id="L785" class="LineNr"> 785 </span>
<span id="L786" class="LineNr"> 786 </span>
<span id="L787" class="LineNr"> 787 </span>Syntax:
<span id="L788" class="LineNr"> 788 </span>puttdata<span class="textRainbow_lv0_p0">(</span>minor_cap<span class="textRainbow_lv0_o0">,</span> string_ptr<span class="textRainbow_lv0_o0">,</span> string_len<span class="textRainbow_lv0_p0">)</span>;
<span id="L789" class="LineNr"> 789 </span>  int minor_cap;
<span id="L790" class="LineNr"> 790 </span>  char *string_ptr;
<span id="L791" class="LineNr"> 791 </span>  int string_len;
<span id="L792" class="LineNr"> 792 </span>
<span id="L793" class="LineNr"> 793 </span>
<span id="L794" class="LineNr"> 794 </span>Arguments:
<span id="L795" class="LineNr"> 795 </span>minor_cap  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L796" class="LineNr"> 796 </span>    The destination minor capability number to receive the
<span id="L797" class="LineNr"> 797 </span>    data.  This is to distinguish between control information
<span id="L798" class="LineNr"> 798 </span>    and regular terminal data.  The minor capability number
<span id="L799" class="LineNr"> 799 </span>    for regular terminal data is WSFGDATA.
<span id="L800" class="LineNr"> 800 </span>string_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L801" class="LineNr"> 801 </span>    A pointer to the character string to be sent.
<span id="L802" class="LineNr"> 802 </span>string_len  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L803" class="LineNr"> 803 </span>    The length of above character string.
<span id="L804" class="LineNr"> 804 </span>
<span id="L805" class="LineNr"> 805 </span>
<span id="L806" class="LineNr"> 806 </span>Returns:
<span id="L807" class="LineNr"> 807 </span>0        - no error.
<span id="L808" class="LineNr"> 808 </span>
<span id="L809" class="LineNr"> 809 </span>
<span id="L810" class="LineNr"> 810 </span>Notes:
<span id="L811" class="LineNr"> 811 </span>
<span id="L812" class="LineNr"> 812 </span>
<span id="L813" class="LineNr"> 813 </span>:Entry:  resetcap:  11/28/86  resetcap
<span id="L814" class="LineNr"> 814 </span>
<span id="L815" class="LineNr"> 815 </span>
<span id="L816" class="LineNr"> 816 </span>Function:
<span id="L817" class="LineNr"> 817 </span>Tells MOWSE to reset the specified application.  The
<span id="L818" class="LineNr"> 818 </span>application to be reset is notified via the predefined minor
<span id="L819" class="LineNr"> 819 </span>capability RESET.
<span id="L820" class="LineNr"> 820 </span>
<span id="L821" class="LineNr"> 821 </span>
<span id="L822" class="LineNr"> 822 </span>Syntax:
<span id="L823" class="LineNr"> 823 </span>int resetcap <span class="textRainbow_lv0_p0">(</span>major_number<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L824" class="LineNr"> 824 </span>  int major_number;
<span id="L825" class="LineNr"> 825 </span>  mcb *mcb_ptr;
<span id="L826" class="LineNr"> 826 </span>
<span id="L827" class="LineNr"> 827 </span>
<span id="L828" class="LineNr"> 828 </span>Arguments:
<span id="L829" class="LineNr"> 829 </span>major_number  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L830" class="LineNr"> 830 </span>    The major capability number of the application to be
<span id="L831" class="LineNr"> 831 </span>    reset.
<span id="L832" class="LineNr"> 832 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L833" class="LineNr"> 833 </span>    The pointer to the caller's MOWSE Control Block.
<span id="L834" class="LineNr"> 834 </span>
<span id="L835" class="LineNr"> 835 </span>
<span id="L836" class="LineNr"> 836 </span>Returns:
<span id="L837" class="LineNr"> 837 </span>0        - no error
<span id="L838" class="LineNr"> 838 </span>Or an error code defined in the appendix.
<span id="L839" class="LineNr"> 839 </span>
<span id="L840" class="LineNr"> 840 </span>
<span id="L841" class="LineNr"> 841 </span>Notes:
<span id="L842" class="LineNr"> 842 </span>MOWSE notifies the application through the predefined minor
<span id="L843" class="LineNr"> 843 </span>capability WSRSTAPP and clears all of the flags associated
<span id="L844" class="LineNr"> 844 </span>with the application.  All messages occurring between the
<span id="L845" class="LineNr"> 845 </span>request and the completion of the request will be discarded by
<span id="L846" class="LineNr"> 846 </span>MOWSE.
<span id="L847" class="LineNr"> 847 </span>
<span id="L848" class="LineNr"> 848 </span>
<span id="L849" class="LineNr"> 849 </span>Examples:
<span id="L850" class="LineNr"> 850 </span>ecode = resetcap <span class="textRainbow_lv0_p0">(</span>bft_major_cap<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L851" class="LineNr"> 851 </span>
<span id="L852" class="LineNr"> 852 </span>
<span id="L853" class="LineNr"> 853 </span>:Entry:  resume:  11/28/86  resume
<span id="L854" class="LineNr"> 854 </span>
<span id="L855" class="LineNr"> 855 </span>
<span id="L856" class="LineNr"> 856 </span>Function:
<span id="L857" class="LineNr"> 857 </span>Tells MOWSE to resume the specified application.  The
<span id="L858" class="LineNr"> 858 </span>application to be resumed is notified via the predefined minor
<span id="L859" class="LineNr"> 859 </span>capability RESM.
<span id="L860" class="LineNr"> 860 </span>
<span id="L861" class="LineNr"> 861 </span>
<span id="L862" class="LineNr"> 862 </span>Syntax:
<span id="L863" class="LineNr"> 863 </span>int resume <span class="textRainbow_lv0_p0">(</span>major_number<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L864" class="LineNr"> 864 </span>  int major_number;
<span id="L865" class="LineNr"> 865 </span>  mcb *mcb_ptr;
<span id="L866" class="LineNr"> 866 </span>
<span id="L867" class="LineNr"> 867 </span>
<span id="L868" class="LineNr"> 868 </span>Arguments:
<span id="L869" class="LineNr"> 869 </span>major_number  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L870" class="LineNr"> 870 </span>    The major capability number of the application to be
<span id="L871" class="LineNr"> 871 </span>    resumed.
<span id="L872" class="LineNr"> 872 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L873" class="LineNr"> 873 </span>    The pointer to the caller's The MOWSE Control Block.
<span id="L874" class="LineNr"> 874 </span>
<span id="L875" class="LineNr"> 875 </span>
<span id="L876" class="LineNr"> 876 </span>Returns:
<span id="L877" class="LineNr"> 877 </span>0        - no error
<span id="L878" class="LineNr"> 878 </span>Or an error code defined in the appendix.
<span id="L879" class="LineNr"> 879 </span>
<span id="L880" class="LineNr"> 880 </span>
<span id="L881" class="LineNr"> 881 </span>Notes:
<span id="L882" class="LineNr"> 882 </span>If the specified capability is not in suspension, the request
<span id="L883" class="LineNr"> 883 </span>will be ignored.  The capability to be resumed is informed via
<span id="L884" class="LineNr"> 884 </span>the predefined minor WSRSMAPP.
<span id="L885" class="LineNr"> 885 </span>
<span id="L886" class="LineNr"> 886 </span>
<span id="L887" class="LineNr"> 887 </span>Examples:
<span id="L888" class="LineNr"> 888 </span>ecode = resume <span class="textRainbow_lv0_p0">(</span>bft_major_cap<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L889" class="LineNr"> 889 </span>
<span id="L890" class="LineNr"> 890 </span>
<span id="L891" class="LineNr"> 891 </span>:Entry:  sendqrep:  11/28/86  sendqrep
<span id="L892" class="LineNr"> 892 </span>
<span id="L893" class="LineNr"> 893 </span>
<span id="L894" class="LineNr"> 894 </span>Function:
<span id="L895" class="LineNr"> 895 </span>Sends the user's response to a query message to the originator
<span id="L896" class="LineNr"> 896 </span>of the background query message <span class="textRainbow_lv0_p0">(</span>see &quot;getbgmes&quot;<span class="textRainbow_lv0_p0">)</span>.
<span id="L897" class="LineNr"> 897 </span>
<span id="L898" class="LineNr"> 898 </span>
<span id="L899" class="LineNr"> 899 </span>Syntax:
<span id="L900" class="LineNr"> 900 </span>int sendqrep <span class="textRainbow_lv0_p0">(</span>reply_string<span class="textRainbow_lv0_o0">,</span> destination_major<span class="textRainbow_lv0_p0">)</span>;
<span id="L901" class="LineNr"> 901 </span>  char *reply_string;
<span id="L902" class="LineNr"> 902 </span>  int destination_major;
<span id="L903" class="LineNr"> 903 </span>
<span id="L904" class="LineNr"> 904 </span>
<span id="L905" class="LineNr"> 905 </span>Arguments:
<span id="L906" class="LineNr"> 906 </span>reply_string  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L907" class="LineNr"> 907 </span>    The user's response to the query message obtained through
<span id="L908" class="LineNr"> 908 </span>    a call to &quot;getbgmes&quot;.
<span id="L909" class="LineNr"> 909 </span>destination_major  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L910" class="LineNr"> 910 </span>    The major capability number of the application which is to
<span id="L911" class="LineNr"> 911 </span>    receive this response string <span class="textRainbow_lv0_p0">(</span>see &quot;getbgmes&quot;<span class="textRainbow_lv0_p0">)</span>.
<span id="L912" class="LineNr"> 912 </span>
<span id="L913" class="LineNr"> 913 </span>
<span id="L914" class="LineNr"> 914 </span>Returns:
<span id="L915" class="LineNr"> 915 </span>0        - no error
<span id="L916" class="LineNr"> 916 </span>Or an error code defined in the appendix.
<span id="L917" class="LineNr"> 917 </span>
<span id="L918" class="LineNr"> 918 </span>
<span id="L919" class="LineNr"> 919 </span>Notes:
<span id="L920" class="LineNr"> 920 </span>A call to this procedure must be performed whenever a WSQUERY
<span id="L921" class="LineNr"> 921 </span>type is returned from &quot;getbgmes&quot; as the requesting application
<span id="L922" class="LineNr"> 922 </span>is waiting for the response.
<span id="L923" class="LineNr"> 923 </span>
<span id="L924" class="LineNr"> 924 </span>
<span id="L925" class="LineNr"> 925 </span>Examples:
<span id="L926" class="LineNr"> 926 </span>ecode = sendqrep <span class="textRainbow_lv0_p0">(</span>user_response<span class="textRainbow_lv0_o0">,</span> sender_major<span class="textRainbow_lv0_p0">)</span>;
<span id="L927" class="LineNr"> 927 </span>
<span id="L928" class="LineNr"> 928 </span>
<span id="L929" class="LineNr"> 929 </span>:Entry:  wssleep:  11/28/86  wssleep
<span id="L930" class="LineNr"> 930 </span>
<span id="L931" class="LineNr"> 931 </span>
<span id="L932" class="LineNr"> 932 </span>Function:
<span id="L933" class="LineNr"> 933 </span>Forces the calling application to sleep <span class="textRainbow_lv0_p0">(</span>suspend execution<span class="textRainbow_lv0_p0">)</span>
<span id="L934" class="LineNr"> 934 </span>for the specified number of seconds.  When an application is
<span id="L935" class="LineNr"> 935 </span>put to sleep, it cannot accept any messages except TERM and
<span id="L936" class="LineNr"> 936 </span>RESET.  The calling application will be notified through the
<span id="L937" class="LineNr"> 937 </span>predefined minor capability WSWAKEUP when the specified time
<span id="L938" class="LineNr"> 938 </span>has elapsed.
<span id="L939" class="LineNr"> 939 </span>
<span id="L940" class="LineNr"> 940 </span>
<span id="L941" class="LineNr"> 941 </span>Syntax:
<span id="L942" class="LineNr"> 942 </span>int wssleep <span class="textRainbow_lv0_p0">(</span>time<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L943" class="LineNr"> 943 </span>  int time;
<span id="L944" class="LineNr"> 944 </span>  mcb *mcb_ptr;
<span id="L945" class="LineNr"> 945 </span>
<span id="L946" class="LineNr"> 946 </span>
<span id="L947" class="LineNr"> 947 </span>Arguments:
<span id="L948" class="LineNr"> 948 </span>time  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L949" class="LineNr"> 949 </span>    The number of seconds the application is to sleep.
<span id="L950" class="LineNr"> 950 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L951" class="LineNr"> 951 </span>    The pointer to the application's MOWSE control block
<span id="L952" class="LineNr"> 952 </span>    assigned by a call to &quot;cretinst&quot;.
<span id="L953" class="LineNr"> 953 </span>
<span id="L954" class="LineNr"> 954 </span>
<span id="L955" class="LineNr"> 955 </span>Returns:
<span id="L956" class="LineNr"> 956 </span>0        - no error
<span id="L957" class="LineNr"> 957 </span>Or an error code defined in the appendix.
<span id="L958" class="LineNr"> 958 </span>
<span id="L959" class="LineNr"> 959 </span>
<span id="L960" class="LineNr"> 960 </span>Notes:
<span id="L961" class="LineNr"> 961 </span>The application is notified to awaken via the predefined minor
<span id="L962" class="LineNr"> 962 </span>capability WSWAKEUP.
<span id="L963" class="LineNr"> 963 </span>It is important that MOWSE applications use THIS sleep
<span id="L964" class="LineNr"> 964 </span>function, as opposed to the sleep routine provided by the
<span id="L965" class="LineNr"> 965 </span>standard &quot;C&quot; library.  MOWSE cannot perform anything until
<span id="L966" class="LineNr"> 966 </span>the application has returned to it, thus all further message
<span id="L967" class="LineNr"> 967 </span>processing would be suspended until the call to the &quot;C&quot; sleep
<span id="L968" class="LineNr"> 968 </span>has expired.
<span id="L969" class="LineNr"> 969 </span>
<span id="L970" class="LineNr"> 970 </span>
<span id="L971" class="LineNr"> 971 </span>Examples:
<span id="L972" class="LineNr"> 972 </span>wssleep <span class="textRainbow_lv0_p0">(</span>10<span class="textRainbow_lv0_p0">)</span>;
<span id="L973" class="LineNr"> 973 </span>
<span id="L974" class="LineNr"> 974 </span>
<span id="L975" class="LineNr"> 975 </span>:Entry:  stayres: 11/28/86  stayres
<span id="L976" class="LineNr"> 976 </span>
<span id="L977" class="LineNr"> 977 </span>
<span id="L978" class="LineNr"> 978 </span>Function:
<span id="L979" class="LineNr"> 979 </span>Terminates execution of a MOWSE capability at the end of its
<span id="L980" class="LineNr"> 980 </span>initialization, and keeps its object code resident in the PC's
<span id="L981" class="LineNr"> 981 </span>memory for later invocations through &quot;execap&quot; calls.
<span id="L982" class="LineNr"> 982 </span>
<span id="L983" class="LineNr"> 983 </span>
<span id="L984" class="LineNr"> 984 </span>Syntax:
<span id="L985" class="LineNr"> 985 </span>stayres <span class="textRainbow_lv0_p0">(</span>mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L986" class="LineNr"> 986 </span>  mcb *mcb_ptr;
<span id="L987" class="LineNr"> 987 </span>
<span id="L988" class="LineNr"> 988 </span>
<span id="L989" class="LineNr"> 989 </span>Arguments:
<span id="L990" class="LineNr"> 990 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L991" class="LineNr"> 991 </span>    The pointer to the application's MOWSE Control Block
<span id="L992" class="LineNr"> 992 </span>    assigned by a call to &quot;cretinst&quot;.
<span id="L993" class="LineNr"> 993 </span>
<span id="L994" class="LineNr"> 994 </span>
<span id="L995" class="LineNr"> 995 </span>Returns:
<span id="L996" class="LineNr"> 996 </span>A call to &quot;stayres&quot; will not return.
<span id="L997" class="LineNr"> 997 </span>
<span id="L998" class="LineNr"> 998 </span>
<span id="L999" class="LineNr"> 999 </span>:Entry:  suspend:  11/28/86  suspend
<span id="L1000" class="LineNr">1000 </span>
<span id="L1001" class="LineNr">1001 </span>
<span id="L1002" class="LineNr">1002 </span>Function:
<span id="L1003" class="LineNr">1003 </span>Tells MOWSE to suspend the specified application.  The
<span id="L1004" class="LineNr">1004 </span>application to be suspended is notified via the predefined
<span id="L1005" class="LineNr">1005 </span>minor capability WSSUSAPP.  A suspended application is unable
<span id="L1006" class="LineNr">1006 </span>to send or receive messages.
<span id="L1007" class="LineNr">1007 </span>
<span id="L1008" class="LineNr">1008 </span>
<span id="L1009" class="LineNr">1009 </span>Syntax:
<span id="L1010" class="LineNr">1010 </span>int suspend <span class="textRainbow_lv0_p0">(</span>major_number<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L1011" class="LineNr">1011 </span>  int major_number;
<span id="L1012" class="LineNr">1012 </span>  mcb *mcb_ptr;
<span id="L1013" class="LineNr">1013 </span>
<span id="L1014" class="LineNr">1014 </span>
<span id="L1015" class="LineNr">1015 </span>Arguments:
<span id="L1016" class="LineNr">1016 </span>major_number  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L1017" class="LineNr">1017 </span>    Capability number of the application to be suspended.
<span id="L1018" class="LineNr">1018 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L1019" class="LineNr">1019 </span>    The pointer to the caller's MOWSE Control Block.
<span id="L1020" class="LineNr">1020 </span>
<span id="L1021" class="LineNr">1021 </span>
<span id="L1022" class="LineNr">1022 </span>Returns:
<span id="L1023" class="LineNr">1023 </span>0        - no error
<span id="L1024" class="LineNr">1024 </span>Or an error code defined in the appendix.
<span id="L1025" class="LineNr">1025 </span>
<span id="L1026" class="LineNr">1026 </span>
<span id="L1027" class="LineNr">1027 </span>Notes:
<span id="L1028" class="LineNr">1028 </span>The specified application will be suspended - unable to send
<span id="L1029" class="LineNr">1029 </span>or receive messages - by MOWSE until a call to &quot;resume&quot; has
<span id="L1030" class="LineNr">1030 </span>been called for that application.
<span id="L1031" class="LineNr">1031 </span>
<span id="L1032" class="LineNr">1032 </span>
<span id="L1033" class="LineNr">1033 </span>Examples:
<span id="L1034" class="LineNr">1034 </span>ecode = suspend <span class="textRainbow_lv0_p0">(</span>bft_major_cap<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L1035" class="LineNr">1035 </span>
<span id="L1036" class="LineNr">1036 </span>
<span id="L1037" class="LineNr">1037 </span>:Entry:  termcap:  11/28/86  termcap
<span id="L1038" class="LineNr">1038 </span>
<span id="L1039" class="LineNr">1039 </span>
<span id="L1040" class="LineNr">1040 </span>Function:
<span id="L1041" class="LineNr">1041 </span>Tells MOWSE to terminate the specified application.  The
<span id="L1042" class="LineNr">1042 </span>application to be terminated is notified via the predefined
<span id="L1043" class="LineNr">1043 </span>minor capability WSTRMAPP.
<span id="L1044" class="LineNr">1044 </span>
<span id="L1045" class="LineNr">1045 </span>
<span id="L1046" class="LineNr">1046 </span>Syntax:
<span id="L1047" class="LineNr">1047 </span>int termcap <span class="textRainbow_lv0_p0">(</span>major_number<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L1048" class="LineNr">1048 </span>  int major_number;
<span id="L1049" class="LineNr">1049 </span>  mcb *mcb_ptr;
<span id="L1050" class="LineNr">1050 </span>
<span id="L1051" class="LineNr">1051 </span>
<span id="L1052" class="LineNr">1052 </span>Arguments:
<span id="L1053" class="LineNr">1053 </span>major_number  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L1054" class="LineNr">1054 </span>    The major capability number of the application to be
<span id="L1055" class="LineNr">1055 </span>    terminated.
<span id="L1056" class="LineNr">1056 </span>mcb_ptr  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L1057" class="LineNr">1057 </span>    The MOWSE Control Block of the calling capability.
<span id="L1058" class="LineNr">1058 </span>
<span id="L1059" class="LineNr">1059 </span>
<span id="L1060" class="LineNr">1060 </span>Returns:
<span id="L1061" class="LineNr">1061 </span>0        - no error
<span id="L1062" class="LineNr">1062 </span>Or an error code defined in the appendix.
<span id="L1063" class="LineNr">1063 </span>
<span id="L1064" class="LineNr">1064 </span>
<span id="L1065" class="LineNr">1065 </span>Notes:
<span id="L1066" class="LineNr">1066 </span>
<span id="L1067" class="LineNr">1067 </span>
<span id="L1068" class="LineNr">1068 </span>Examples:
<span id="L1069" class="LineNr">1069 </span>ecode = termcap <span class="textRainbow_lv0_p0">(</span>bft_major_cap<span class="textRainbow_lv0_o0">,</span> mcb_ptr<span class="textRainbow_lv0_p0">)</span>;
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
